#!/usr/bin/perl -w

#use lib qw(/home/katzung/perl_lib);
use Data::Dumper;
use Text::FF::Layout;
use Text::FF::Record;
use TestLayout;

my $type_map = {
	'rec_id' => '10',
	'type1' => '7 %>+$.2f',
	'type2' => '7 %>_$.2f',
};

my $l1 = Text::FF::Layout->new('name' => 'l1',
	'layout' => [ qw(
	rec_id	10
	sep	1
	num1	type1
	num2	type2
	eor	1
	) ],
	'initial' => { 'rec_id' => 'initial' },
	'constant' => { 'eor' => '~' },
	'type_map' => $type_map,
);

#print "l1 = $l1\nget_by_name = ", Text::FF::Layout->get_by_name('l1'), "\n";

#print Dumper($l1), "\n";
my $r1 = Text::FF::Record->new('layout' => $l1);
my $val;
my $af;

$val = $r1->get();
print "r1 = $val\n";

#$r1->set_field('rec_id' => 'test', 'sep' => '|', 'num1' => 25, 'num2' => 25, 'eor' => '~');
$r1->set_field('rec_id' => 'test', 'sep' => '|', 'num1' => 25, 'num2' => 25, 'eor' => '!');
print "expect r1 rec_id = test, num1 = 25, num2 = 25\n";
print "r1 rec_id = ", $r1->get_field('rec_id'),
  ", num1 = ", $r1->get_field('num1'),
  ", num2 = ", $r1->get_field('num2'), "\n";
$val = $r1->get();
print "r1 = $val\n";

$af = $r1->get_all_fields();
print Dumper($af);

my $l2 = Text::FF::Layout->new('name' => 'l2', 'clone' => 'l1');
#print Dumper($l2);
my $r2 = Text::FF::Record->new('value' => $val);
print "r2 = ", $r2->get(), "\n";
$r2->layout($l2);
#print Dumper($r2), "\n";
print "r2 rec_id = ", $r2->get_field('rec_id'),
  ", num1 = ", $r2->get_field('num1'),
  ", num2 = ", $r2->get_field('num2'), "\n";
$r2->set_field('num1', -42, 'num2', -42);
print "r2 num1 = ", $r2->get_field('num1'), ", num2 = ", $r2->get_field('num2'), "\n";
print "r2 = ", $r2->get(), "\n";

$af = $r2->get_all_fields();
print Dumper($af);

my $l3 = TestLayout->new('name' => 'l3', 'clone' => 'l1');

print "l1 with rec_id changed to initial list\n";
$l1->add_initial('rec_id' => 'initial list');
print Dumper($l1->get_initial());

print "l1 with rec_id changed to initial hashref\n";
$l1->add_initial({ 'rec_id' => 'initial hashref' });
print Dumper($l1->get_initial());

print "r2 layout after reset to l3 (by name)\n";
$r2->reset('l3');
print Dumper($r2->layout());
